mkrootfs.sh.in 9.2 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275
  1. #!/bin/sh
  2. #-
  3. # Copyright (c) 2013-2015 Juan Romero Pardines.
  4. # All rights reserved.
  5. #
  6. # Redistribution and use in source and binary forms, with or without
  7. # modification, are permitted provided that the following conditions
  8. # are met:
  9. # 1. Redistributions of source code must retain the above copyright
  10. # notice, this list of conditions and the following disclaimer.
  11. # 2. Redistributions in binary form must reproduce the above copyright
  12. # notice, this list of conditions and the following disclaimer in the
  13. # documentation and/or other materials provided with the distribution.
  14. #
  15. # THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
  16. # IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
  17. # OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
  18. # IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
  19. # INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
  20. # NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
  21. # DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
  22. # THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
  23. # (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
  24. # THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
  25. #-
  26. readonly PROGNAME=$(basename $0)
  27. readonly ARCH=$(uname -m)
  28. trap 'die "Interrupted! exiting..."' INT TERM HUP
  29. info_msg() {
  30. printf "\033[1m$@\n\033[m"
  31. }
  32. die() {
  33. echo "FATAL: $@"
  34. umount_pseudofs
  35. [ -d "$rootfs" ] && rm -rf $rootfs
  36. exit 1
  37. }
  38. usage() {
  39. cat <<_EOF
  40. Usage: $PROGNAME [options] <platform>
  41. Supported platforms: i686, i686-musl, x86_64, x86_64-musl,
  42. dockstar, bananapi, beaglebone, cubieboard2, cubietruck,
  43. odroid-c2, odroid-u2, rpi, rpi2 (armv7), usbarmory, ci20
  44. Options
  45. -b <syspkg> Set an alternative base-system package (defaults to base-system)
  46. -c <dir> Set XBPS cache directory (defaults to \$PWD/xbps-cachedir-<arch>)
  47. -C <file> Full path to the XBPS configuration file
  48. -h Show this help
  49. -p <pkgs> Additional packages to install into the rootfs (separated by blanks)
  50. -r <repo> Set XBPS repository (may be set multiple times)
  51. -k <cmd> Call "cmd <ROOTFSPATH>" after building the rootfs
  52. -V Show version
  53. _EOF
  54. }
  55. mount_pseudofs() {
  56. for f in dev proc sys; do
  57. [ ! -d $rootfs/$f ] && mkdir -p $rootfs/$f
  58. mount -r --bind /$f $rootfs/$f
  59. done
  60. }
  61. umount_pseudofs() {
  62. if [ -d "${rootfs}" ]; then
  63. for f in dev proc sys; do
  64. umount -f $rootfs/$f >/dev/null 2>&1
  65. done
  66. fi
  67. }
  68. run_cmd_target() {
  69. info_msg "Running $@ for target $_ARCH ..."
  70. case "${_TARGET_ARCH}" in
  71. i686*|x86_64*) eval XBPS_ARCH=${_TARGET_ARCH} "$@";;
  72. *) eval XBPS_TARGET_ARCH=${_TARGET_ARCH:=${_ARCH}} "$@";;
  73. esac
  74. [ $? -ne 0 ] && die "Failed to run $@"
  75. }
  76. run_cmd() {
  77. info_msg "Running $@ ..."
  78. eval "$@"
  79. [ $? -ne 0 ] && die "Failed to run $@"
  80. }
  81. register_binfmt() {
  82. if [ "$ARCH" = "${_ARCH}" ]; then
  83. return 0
  84. fi
  85. mountpoint -q /proc/sys/fs/binfmt_misc || modprobe -q binfmt_misc; mount -t binfmt_misc binfmt_misc /proc/sys/fs/binfmt_misc
  86. case "${_ARCH}" in
  87. armv*)
  88. echo ':arm:M::\x7fELF\x01\x01\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\x28\x00:\xff\xff\xff\xff\xff\xff\xff\x00\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff\xff:/usr/bin/qemu-arm-static:' > /proc/sys/fs/binfmt_misc/register
  89. ;;
  90. aarch*)
  91. echo ':qemu-arm64:M::\x7fELF\x02\x01\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\xb7:\xff\xff\xff\xff\xff\xff\xff\x00\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff:/usr/bin/qemu-aarch64-static:' > /proc/sys/fs/binfmt_misc/register
  92. ;;
  93. mipsel*)
  94. echo ':mipsel:M::\x7fELF\x01\x01\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\x08\x00:\xff\xff\xff\xff\xff\xff\xff\x00\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff\xff:/usr/bin/qemu-mipsel-static:' > /proc/sys/fs/binfmt_misc/register
  95. ;;
  96. *)
  97. die "Unknown target architecture!"
  98. ;;
  99. esac
  100. cp -f $(which $QEMU_BIN) $rootfs/usr/bin || die "failed to copy $QEMU_BIN to the rootfs"
  101. }
  102. #
  103. # main()
  104. #
  105. while getopts "b:C:c:hp:r:k:V" opt; do
  106. case $opt in
  107. b) PKGBASE="$OPTARG";;
  108. C) XBPS_CONFFILE="-C $OPTARG";;
  109. c) XBPS_CACHEDIR="--cachedir=$OPTARG";;
  110. h) usage; exit 0;;
  111. p) EXTRA_PKGS="$OPTARG";;
  112. r) XBPS_REPOSITORY="$XBPS_REPOSITORY --repository=$OPTARG";;
  113. k) POST_HOOK="$OPTARG";;
  114. V) echo "$PROGNAME @@MKLIVE_VERSION@@"; exit 0;;
  115. esac
  116. done
  117. shift $(($OPTIND - 1))
  118. PLATFORM="$1"
  119. SUBPLATFORM=$PLATFORM
  120. case "$PLATFORM" in
  121. i686*) _TARGET_ARCH="$PLATFORM"; _ARCH="i686";;
  122. x86_64*) _TARGET_ARCH="$PLATFORM"; _ARCH="x86_64";;
  123. dockstar) _TARGET_ARCH="armv5tel"; _ARCH="armv5tel";;
  124. rpi-musl) _TARGET_ARCH="armv6l-musl"; _ARCH="armv6l";;
  125. rpi) _TARGET_ARCH="armv6l"; _ARCH="armv6l";;
  126. ci20-musl) _TARGET_ARCH="mipselhf-musl"; _ARCH="mipsel-musl";;
  127. ci20) _TARGET_ARCH="mipselhf"; _ARCH="mipsel";;
  128. odroid-c2-musl) _TARGET_ARCH="aarch64-musl"; _ARCH="aarch64";;
  129. odroid-c2) _TARGET_ARCH="aarch64"; _ARCH="aarch64";;
  130. *-musl) _TARGET_ARCH="armv7l-musl"; _ARCH="armv7l";;
  131. *) _TARGET_ARCH="armv7l"; _ARCH="armv7l";;
  132. esac
  133. : ${XBPS_REPOSITORY:=--repository=http://repo.voidlinux.eu/current --repository=http://muslrepo.voidlinux.eu/current}
  134. : ${XBPS_CACHEDIR:=--cachedir=$PWD/xbps-cachedir-${_TARGET_ARCH}}
  135. case "$PLATFORM" in
  136. i686*|x86_64*) PKGBASE="base-voidstrap";;
  137. *) PKGBASE="base-system";;
  138. esac
  139. if [ -z "$PLATFORM" ]; then
  140. echo "$PROGNAME: platform was not set!"
  141. usage; exit 1
  142. fi
  143. case "$PLATFORM" in
  144. bananapi*) SUBPLATFORM=${PLATFORM%-*}; QEMU_BIN=qemu-arm-static;;
  145. beaglebone*) SUBPLATFORM=${PLATFORM%-*}; QEMU_BIN=qemu-arm-static;;
  146. cubieboard2*|cubietruck*) SUBPLATFORM=${PLATFORM%-*}; QEMU_BIN=qemu-arm-static;;
  147. dockstar*) SUBPLATFORM=${PLATFORM%-*}; QEMU_BIN=qemu-arm-static;;
  148. odroid-u2*) SUBPLATFORM=${PLATFORM%-*}; QEMU_BIN=qemu-arm-static;;
  149. rpi2*) SUBPLATFORM=rpi; QEMU_BIN=qemu-arm-static;;
  150. rpi*) SUBPLATFORM=${PLATFORM%-*}; QEMU_BIN=qemu-arm-static;;
  151. usbarmory*) SUBPLATFORM=${PLATFORM%-*}; QEMU_BIN=qemu-arm-static;;
  152. ci20*) SUBPLATFORM=${PLATFORM%-*}; QEMU_BIN=qemu-mipsel-static;;
  153. odroid-c2*) SUBPLATFORM=${PLATFORM%-musl}; QEMU_BIN=qemu-aarch64-static;;
  154. i686*) QEMU_BIN=qemu-i386-static;;
  155. x86_64*) QEMU_BIN=qemu-x86_64-static;;
  156. *) die "$PROGNAME: invalid platform!";;
  157. esac
  158. if [ "$(id -u)" -ne 0 ]; then
  159. die "need root perms to continue, exiting."
  160. fi
  161. #
  162. # Check for required binaries.
  163. #
  164. for f in chroot tar xbps-install xbps-reconfigure xbps-query; do
  165. if ! $f --version >/dev/null 2>&1; then
  166. die "$f binary is missing in your system, exiting."
  167. fi
  168. done
  169. if ! $QEMU_BIN -version >/dev/null 2>&1; then
  170. die "$QEMU_BIN binary is missing in your system, exiting."
  171. fi
  172. #
  173. # Check if package base-system is available.
  174. #
  175. rootfs=$(mktemp -d) || die "failed to create tempdir, exiting..."
  176. mkdir -p $rootfs/var/db/xbps/keys
  177. cp keys/*.plist $rootfs/var/db/xbps/keys
  178. run_cmd_target "xbps-install -S $XBPS_CONFFILE $XBPS_CACHEDIR $XBPS_REPOSITORY -r $rootfs"
  179. run_cmd_target "xbps-query -R -r $rootfs $XBPS_CONFFILE $XBPS_CACHEDIR $XBPS_REPOSITORY -ppkgver $PKGBASE"
  180. chmod 755 $rootfs
  181. case "$PLATFORM" in
  182. i686*|x86_64*) PKGS="${PKGBASE}" ;;
  183. *) PKGS="${PKGBASE} ${SUBPLATFORM}-base" ;;
  184. esac
  185. [ -n "$EXTRA_PKGS" ] && PKGS="${PKGS} ${EXTRA_PKGS}"
  186. mount_pseudofs
  187. #
  188. # Install base-system to the rootfs directory.
  189. #
  190. run_cmd_target "xbps-install -S $XBPS_CONFFILE $XBPS_CACHEDIR $XBPS_REPOSITORY -r $rootfs -y ${PKGS}"
  191. # Enable en_US.UTF-8 locale and generate it into the target rootfs.
  192. if [ -e $rootfs/etc/default/libc-locales ]; then
  193. LOCALE=en_US.UTF-8
  194. sed -e "s/\#\(${LOCALE}.*\)/\1/g" -i $rootfs/etc/default/libc-locales
  195. fi
  196. #
  197. # Reconfigure packages for target architecture: must be reconfigured
  198. # thru the qemu user mode binary.
  199. #
  200. if [ -n "${_ARCH}" ]; then
  201. info_msg "Reconfiguring packages for ${_ARCH} ..."
  202. case "$PLATFORM" in
  203. i686*|x86_64*)
  204. run_cmd "XBPS_ARCH=${PLATFORM} xbps-reconfigure -r $rootfs base-files"
  205. ;;
  206. *)
  207. register_binfmt
  208. run_cmd "xbps-reconfigure -r $rootfs base-files"
  209. run_cmd "chroot $rootfs env -i xbps-reconfigure -f base-files"
  210. rmdir $rootfs/usr/lib32 2>/dev/null
  211. rm -f $rootfs/lib32 $rootfs/lib64 $rootfs/usr/lib64
  212. ;;
  213. esac
  214. run_cmd "chroot $rootfs xbps-reconfigure -a"
  215. fi
  216. #
  217. # Setup default root password.
  218. #
  219. run_cmd "chroot $rootfs sh -c 'echo "root:voidlinux" | chpasswd -c SHA512'"
  220. if [ -n "$POST_HOOK" ]; then
  221. run_cmd "$POST_HOOK $rootfs"
  222. fi
  223. umount_pseudofs
  224. #
  225. # Cleanup rootfs.
  226. #
  227. rm -f $rootfs/etc/.pwd.lock 2>/dev/null
  228. rm -rf $rootfs/var/cache/* 2>/dev/null
  229. #
  230. # Generate final tarball.
  231. #
  232. arch=$ARCH
  233. if [ -n "${_ARCH}" ]; then
  234. rm -f $rootfs/usr/bin/$QEMU_BIN
  235. arch=${_ARCH}
  236. fi
  237. tarball=void-${PLATFORM}-rootfs-$(date '+%Y%m%d').tar.xz
  238. run_cmd "tar -cp --posix --xattrs -C $rootfs . | xz -T0 -9 > $tarball "
  239. rm -rf $rootfs
  240. info_msg "Successfully created $tarball ($PLATFORM)"
  241. # vim: set ts=4 sw=4 et: